from Shape2D import Shape2D

import math

class Circle(Shape2D):
    """A simple implementation of a circle. It maintains an (x,y) location
       of the circle's center and its radius."""

    def __init__(self, x=0, y=0, radius=1.0):
        super(Circle, self).__init__(x, y)
        self.radius = radius

    def getArea(self):
        """Calculate the area of the circle."""
        return math.pi * (self.radius ** 2)

    def getPerimeter(self):
        """Calculate the perimeter of the circle."""
        return 2.0 * math.pi * self.radius

    def getRadius(self):
        return self.radius

    def scale(self, factor=1.0):
        """Change the radius of the circle by a given factor."""
        self.radius  *= factor

    def setRadius(self, radius):
        self.radius = radius

    def report(self):
        """Generate a string containing the current values of the
           circle's attributes."""
        line1 = "Circle:"
        line2 = super(Circle, self).report()
        line3 = "    radius: %G" % (self.radius)
        return "%s\n%s\n%s" % (line1, line2, line3)
