from Shape import Shape

class Line(Shape):

    """A simple implementation of a line. It maintains an (x,y) location
       of the left endpoint of the line, as well as its slope and length."""

    def __init__(self, x=0, y=0, slope=0.5, length=1.0):
        super(Line, self).__init__(x, y)
        self.slope = slope
        self.length = length

    def getLength(self):
        return self.length

    def getSlope(self):
        return self.slope

    def scale(self, factor=1.0):
        """Change the length of the line by a given factor."""
        self.length  *= factor

    def setLength(self, length):
        self.length = length

    def setSlope(self, slope):
        self.slope = slope
        
    def report(self):
        """Generate a string containing the current values of the
           line's attributes."""
        line1 = "Line:"
        line2 = super(Line, self).report()
        line3 = "    slope: %G" % (self.slope)
        line4 = "    length: %G" % (self.length)
        return "%s\n%s\n%s\n%s" % (line1, line2, line3, line4)
