from Shape2D import Shape2D

class Rectangle(Shape2D):

    """A simple implementation of a rectangle. It maintains an (x,y) location
       of the top-left corner of the rectangle, as well as its width and height."""

    def __init__(self, x=0, y=0, width=1.0, height=1.0):
        super(Rectangle, self).__init__(x, y)
        self.width = width
        self.height = height

    def getArea(self):
        """Calculate the area of the rectangle."""
        return self.width * self.height

    def getWidth(self):
        return self.width

    def getHeight(self):
        return self.height

    def getPerimeter(self):
        """Calculate the perimeter of the rectangle."""
        return (self.width*2) + (self.height*2)

    def scale(self, factor=1.0):
        """Change the width and height of the rectangle by a given factor."""
        self.width  *= factor
        self.height *= factor

    def setWidth(self, width):
        self.width = width

    def setHeight(self, height):
        self.height = height

    def report(self):
        """Generate a string containing the current values of the
           rectangle's attributes."""
        line1 = "Rectangle:"
        line2 = super(Rectangle, self).report()
        line3 = "    width: %G" % (self.width)
        line4 = "    height: %G" % (self.height)
        return "%s\n%s\n%s\n%s" % (line1, line2, line3, line4)
