class Shape(object):

    """Shape is an abstract base class for shapes that maintains
       an (x,y) coordinate for all Shape subclasses. It defines
       one abstract method, scale(), which can be used to
       modify a shape's size by a given factor."""

    def __init__(self, x=0, y=0):
        self.x = x
        self.y = y

    def getX(self):
        return self.x

    def getY(self):
        return self.y

    def setX(self, x):
        self.x = x

    def setY(self, y):
        self.y = y

    def scale(self, factor=1.0):
        pass
        
    def report(self):
        """Generates a string containing infromation
           on the (x,y) coordinate for all shape objects."""
        line1 = "    x: %d" % (self.getX())
        line2 = "    y: %d" % (self.getY())
        return "%s\n%s" % (line1, line2)
