from Shape import Shape

class Shape2D(Shape):

    """Shape2D is an abstract base class for shapes that have an
       interior and therefore can have an area and a perimeter."""

    def __init__(self, x=0, y=0):
        super(Shape2D, self).__init__(x, y)

    def getArea(self):
        """All subclasses of Shape2D should be able to calculate
           the area for their type of shape."""
        pass
        
    def getPerimeter(self):
        """All subclasses of Shape2D should be able to calculate
           the perimeter for their type of shape."""
        pass

    def report(self):
        """Generates a string containing information about
           the area and perimeter of a Shape2D object."""
        line1 = super(Shape2D, self).report()
        line2 = "    area: %G" % (self.getArea())
        line3 = "    perimeter: %G" % (self.getPerimeter())
        return "%s\n%s\n%s" % (line1, line2, line3)

