from Shape2D import Shape2D

class Square(Shape2D):

    """A simple implementation of a square. It maintains an (x,y) location
       of the top-left corner of the square, as well as the length of its sides."""

    def __init__(self, x=0, y=0, length=1.0):
        super(Square, self).__init__(x, y)
        self.length = length

    def getArea(self):
        """Calculate the area of the square."""
        return self.length ** 2

    def getLength(self):
        return self.length

    def getPerimeter(self):
        """Calculate the perimeter of the square."""
        return self.length*4

    def scale(self, factor=1.0):
        """Change the length of the square's sides by a given factor."""
        self.length  *= factor

    def setLength(self, length):
        self.length = length

    def report(self):
        """Generate a string containing the current values of the
           square's attributes."""
        line1 = "Square:"
        line2 = super(Square, self).report()
        line3 = "    length: %G" % (self.length)
        return "%s\n%s\n%s" % (line1, line2, line3)
