from Canvas    import Canvas
from Circle    import Circle
from Line      import Line
from Rectangle import Rectangle
from Square    import Square

import random

# step 1: create canvas
c  = Canvas(600, 600)

minX = c.minX()
minY = c.minY()
maxX = c.maxX()
maxY = c.maxY()

def createRandomShape():
    selection = random.randint(1,4)
    if selection == 1:
        return Circle(random.randint(minX, maxX), random.randint(minY, maxY), random.uniform(1.0, 100.0))
    elif selection == 2:
        return Square(random.randint(minX, maxX), random.randint(minY, maxY), random.uniform(1.0, 100.0))
    elif selection == 3:
        return Rectangle(random.randint(minX, maxX), random.randint(minY, maxY), random.uniform(1.0, 100.0), random.uniform(1.0, 100.0))
    else:
        return Line(random.randint(minX, maxX), random.randint(minY, maxY), random.random(), random.uniform(1.0, 100.0))

numShapes = random.randint(5, 10)

# step 2: create random shapes
for index in range(numShapes):
    c.add(createRandomShape())

c.report()

# step 3 and 4: randomly move or scale 20 objects
for index in range(20):
    s = c.getRandomShape()
    selection = random.randint(1, 2)
    if selection == 1:
        deltaX = random.randint(-20, 20)
        deltaY = random.randint(-20, 20)
        print "Moving Shape at (%d,%d) by (%d, %d)." % (s.getX(), s.getY(), deltaX, deltaY)
        c.moveShapeBy(s, deltaX, deltaY)
    else:
        factor = random.uniform(0.1, 5.0)
        print "Scaling Shape at (%d,%d) by a factor of %G." % (s.getX(), s.getY(), factor)
        s.scale(factor)
    c.report()

# step 5: align farthest x-axis shapes vertically

minShape = c.shapeWithMinX()
maxShape = c.shapeWithMaxX()

print "Aligning Vertically:"
print "%s\n" % (minShape.report())
print "%s\n" % (maxShape.report())

c.alignVertically([minShape, maxShape])
c.report()


# step 6: align farthest y-axis shapes horizontally

minShape = c.shapeWithMinY()
maxShape = c.shapeWithMaxY()

print "Aligning Horizontally:"
print "%s\n" % (minShape.report())
print "%s\n" % (maxShape.report())

c.alignHorizontally([minShape, maxShape])
c.report()
